// Thanks Golden (Conker#7086) and Amperbee (Rapidgame7#1949) with the code!
local function slowMovement(player)
	if player.mo.skin == "sonic"	
        player.normalspeed = 9*FRACUNIT

        if (player.pflags & PF_FINISHED)
			or player.powers[pw_sneakers] 
			or player.powers[pw_super]
			
            player.normalspeed = skins["sonic"].normalspeed
        end
		
        if (player.cmd.buttons & BT_SPIN)
			and P_SuperReady(player)
			
            P_DoSuperTransformation(player)
        end
    end
end

addHook("PlayerThink", slowMovement)

local function springJump(player)
	if player.mo.skin ~= "sonic"
		or player.powers[pw_super]
		or player.powers[pw_carry]
		return
	end
	
	if P_IsObjectOnGround(player.mo)
		local spring = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_BLUESPRING)
		spring.fuse = 2*TICRATE
		return true
	end
end

addHook("JumpSpecial", springJump)

local function reCurl(player)
	if (player.mo.state == S_PLAY_SPRING or player.mo.state == S_PLAY_FALL) 
		if (player.cmd.buttons & BT_SPIN)
			player.pflags = $ + PF_JUMPED
			player.mo.state = S_PLAY_JUMP
			S_StartSound(player.mo, sfx_spin, player)
		end
	end
end

addHook("PlayerThink", reCurl)

local function downwardsThok(player)
	if player.mo.skin ~= "sonic"
		or player.powers[pw_super]
		or player.powers[pw_carry]
		return
	end

	if not player.thoked
		S_StartSound(player.mo, sfx_thok, player)
		local dt = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_THOK)
		dt.color = player.skincolor
		player.mo.momx = 0
		player.mo.momy = 0
		player.mo.momz = (25 *  FRACUNIT) * -P_MobjFlip(player.mo)
		player.mo.state = S_PLAY_FALL
		player.thoked = 1
	end
	
	return true
end

addHook("AbilitySpecial", downwardsThok)

addHook("PlayerThink", function(player)
	if P_IsObjectOnGround(player.mo)
		and player.thoked
			
		player.thoked = 0
	end
end)

addHook("PlayerCanDamage", function(player, mo)
	if player.thoked == 1
		player.thoked = 0
		player.pflags = $ & ~PF_JUMPED
		return true
	else
		return
	end
end)

addHook("PlayerThink", function(player)
	if player.thoked == 1
		and (player.mo.eflags & MFE_SPRUNG)
		
		player.mo.momz = FixedMul($, (6*FRACUNIT/5))
		S_StartSound(spring, sfx_sprong, player)
	end
end)